//
//  UpnpDevice.m
//  uPnp2
//
//  Created by rk on 3/01/11.
//  Copyright 2011 Interchart. All rights reserved.
//

#import <Foundation/NSStream.h>
#import "UpnpDevice.h"


@implementation UpnpDevice

@synthesize _deviceType;
@synthesize _url;
@synthesize _readData;
@synthesize _deviceInfo;

- (id)init {
	self = [super init];
	return self;
}

- (void) dealloc {
	[super dealloc];
	[_readData release];
	_readData = nil;
	[_url release];
	_url = nil;
	[_deviceInfo release];
	_deviceInfo = nil;
}


- (void) fetchDeviceInfo {
	UpnpDevice *device = self;
	NSURL *deviceInfoUrl = device._url;
		
	NSURLRequest *request = [NSURLRequest 
							 requestWithURL:deviceInfoUrl 
							 cachePolicy:NSURLRequestReloadIgnoringCacheData 
							 timeoutInterval:30];
	// Clear out the existing connection if there is one
	if (_connectionInProgress) {
		[_connectionInProgress cancel];
		[_connectionInProgress release];
	}
	
	[_readData release];
	_readData = [[NSMutableData alloc] init];
	
	// Create and initiate the connection - non-blocking
	_connectionInProgress = [[NSURLConnection alloc] initWithRequest:request
															delegate:self
													startImmediately:YES];
}

//This method will be called several times as the data arrives
- (void) connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
	[_readData appendData: data];
}

- (void) connectionDidFinishLoading:(NSURLConnection *)connection {
	NSLog(@"finished receiving info data from device, %@", [self _requestResponse ]);
	UpnpDeviceInfo *deviceInfo = [[UpnpDeviceInfo alloc] initWithXml:_readData];
	_deviceInfo = deviceInfo;
	NSLog(@"deviceInfo: %@", _deviceInfo);
	
}

#pragma mark -

- (NSString *)_requestResponse {
	return [NSString stringWithFormat: @"response:\r\n%@\r\n",
			[NSString stringWithUTF8String:[_readData bytes]]];
}

@end
